package PureMessage::List::SpecialAddrs;

use strict;

use base 'PureMessage::List::Items';

# RFC 1918 and http://www.iana.org/assignments/ipv4-address-space
my @private_ipv4_addrs = qw(
    10.0.0.0/8
    172.16.0.0/12
    192.168.0.0/16
    );

my @iana_ipv4_addrs = map { "$_.0.0.0/8" } (0,127,224..255);

#http://www.iana.org/assignments/ipv6-address-space/ipv6-address-space.xml
my @private_ipv6_addrs = qw(FC00::/7 FE80::/10);

my @iana_ipv6_addrs = qw(
    0000::/8 0100::/8 0200::/7 
    0400::/6 0800::/5 1000::/4 
    4000::/3 6000::/3 8000::/3 
    A000::/3 C000::/3 E000::/4 
    F000::/5 F800::/6 FE00::/9 
    FEC0::/10 FF00::/8
    );

sub new {
    my $cls = shift;
    return $cls->SUPER::new(
	items => [@private_ipv4_addrs, @iana_ipv4_addrs, @private_ipv6_addrs, @iana_ipv6_addrs],
	match_type => 'domain',
    );
}

1;
